<template>
  <li class="ui-sidebar-nav-item" :class="item.customClass">
    <component
      :is="item.tag || 'a'"
      v-bind="itemData"
      class="[&_.icon]:-mt-[0.2em] [&_.icon]:inline [&_.icon]:size-[1.1em] [&_.icon]:fill-current"
      :class="{
        '-mx-[0.35em] rounded box-decoration-clone p-[0.35em] no-underline transition-colors hover:bg-violet-100 aria-current-page:bg-violet-100 aria-current-page:text-violet-800 hover:aria-current-page:bg-violet-200 sm:-mx-[0.275em] sm:p-[0.275em] lg:-mx-[0.35em] lg:p-[0.35em]':
          compilesToAnchorElement(item.tag),
        ...(item.customInnerClass && { [item.customInnerClass]: true }),
      }"
      :active-class="
        isRouterLink(item.tag) && item.matchNonExactRoute
          ? 'bg-violet-100 text-violet-800 hover:bg-violet-200'
          : null
      "
    >
      <slot name="iconLeft">
        <ui-svg-icon
          v-if="item.iconLeft"
          class="icon mr-1"
          :name="item.iconLeft"
        />
      </slot>
      {{ item.label }}
      <slot name="iconRight">
        <ui-svg-icon
          v-if="item.iconRight"
          class="icon ml-1"
          :name="item.iconRight"
        />
      </slot>
    </component>
    <component
      :is="item.hasOrderedChildren ?? parentIsOrderedList ? 'ol' : 'ul'"
      v-if="item.children?.length"
      class="leading-normal"
    >
      <ui-sidebar-nav-item
        v-for="child of item.children"
        :key="child.label"
        :item="child"
        :parent-is-ordered-list="item.hasOrderedChildren ?? parentIsOrderedList"
        class="!-mt-[0.1em] -ml-4"
      />
    </component>
  </li>
</template>

<script lang="ts" setup>
import { computed, PropType } from 'vue'
import { SidebarNavItemData } from '../../propInterfaces'
import UiSvgIcon from './SvgIcon.vue'

defineOptions({
  name: 'UiSidebarNavItem',
})

const props = defineProps({
  parentIsOrderedList: {
    type: Boolean,
    default: false,
  },
  item: {
    type: Object as PropType<SidebarNavItemData>,
    required: true,
  },
})

const itemData = computed(() => {
  const {
    label,
    tag,
    children,
    hasOrderedChildren,
    matchNonExactRoute,
    customClass,
    customInnerClass,
    ...itemData
  } = props.item

  return itemData
})

/**
 * Helper to determine if `item.tag` compiles down to an anchor element.
 */
function compilesToAnchorElement(tag: string = 'a') {
  return ['a', 'A'].includes(tag) || isRouterLink(tag)
}

/**
 * Helper to determine if the item is an instance of `RouterLink`.
 */
function isRouterLink(tag: string = 'a') {
  return ['router-link', 'RouterLink', 'nuxt-link', 'NuxtLink'].includes(tag)
}
</script>
